# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperFindContactCommand.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class PR2GripperFindContactCommand(genpy.Message):
  _md5sum = "4a38a1a8e495aae86921ef2b292ec260"
  _type = "pr2_gripper_sensor_msgs/PR2GripperFindContactCommand"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# set true if you want to calibrate the fingertip sensors on the start
# of the find_contact action. While this is not necessary (and
# the default value will not calibrate the sensors) for best 
# performance it is recommended that you set this to true each time 
# you are calling find_contact and are confident the fingertips are 
# not touching anything
# NOTE: SHOULD ONLY BE TRUE WHEN BOTH FINGERS ARE TOUCHING NOTHING
bool zero_fingertip_sensors

# the finger contact conditions that determine what our goal is
# Leaving this field blank will result in the robot closing until
# contact on BOTH fingers is achieved
int8 contact_conditions

# predefined values for the above contact_conditions variable
int8 BOTH = 0   # both fingers must make contact
int8 LEFT = 1   # just the left finger 
int8 RIGHT = 2  # just the right finger
int8 EITHER = 3 # either finger, we don't care which
"""
  # Pseudo-constants
  BOTH = 0
  LEFT = 1
  RIGHT = 2
  EITHER = 3

  __slots__ = ['zero_fingertip_sensors','contact_conditions']
  _slot_types = ['bool','int8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       zero_fingertip_sensors,contact_conditions

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperFindContactCommand, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.zero_fingertip_sensors is None:
        self.zero_fingertip_sensors = False
      if self.contact_conditions is None:
        self.contact_conditions = 0
    else:
      self.zero_fingertip_sensors = False
      self.contact_conditions = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Bb().pack(_x.zero_fingertip_sensors, _x.contact_conditions))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.zero_fingertip_sensors, _x.contact_conditions,) = _get_struct_Bb().unpack(str[start:end])
      self.zero_fingertip_sensors = bool(self.zero_fingertip_sensors)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Bb().pack(_x.zero_fingertip_sensors, _x.contact_conditions))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.zero_fingertip_sensors, _x.contact_conditions,) = _get_struct_Bb().unpack(str[start:end])
      self.zero_fingertip_sensors = bool(self.zero_fingertip_sensors)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Bb = None
def _get_struct_Bb():
    global _struct_Bb
    if _struct_Bb is None:
        _struct_Bb = struct.Struct("<Bb")
    return _struct_Bb
