# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperSlipServoData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import pr2_gripper_sensor_msgs.msg

class PR2GripperSlipServoData(genpy.Message):
  _md5sum = "a49728a2e0c40706b3c9b74046f006aa"
  _type = "pr2_gripper_sensor_msgs/PR2GripperSlipServoData"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# time the data was recorded at
time stamp

# the amount of deformation from action start (in meters)
float64 deformation

# the force experinced by the finger Pads  (N)
# NOTE:this ignores data from the edges of the finger pressure
float64 left_fingertip_pad_force
float64 right_fingertip_pad_force

# the current virtual parallel joint effort of the gripper (in N)
float64 joint_effort

# true if the object recently slipped
bool slip_detected

# true if we are at or exceeding the deformation limit
# (see wiki page and param server for more info)
bool deformation_limit_reached

# true if we are at or exceeding our force 
# (see wiki page and param server for more info)
bool fingertip_force_limit_reached

# true if the controller thinks the gripper is empty
# (see wiki page for more info)
bool gripper_empty

# the control state of our realtime controller
PR2GripperSensorRTState rtstate
================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperSensorRTState
# the control state of our realtime controller
int8 realtime_controller_state

# predefined values to indicate our realtime_controller_state
int8 DISABLED = 0
int8 POSITION_SERVO = 3
int8 FORCE_SERVO = 4
int8 FIND_CONTACT = 5
int8 SLIP_SERVO = 6"""
  __slots__ = ['stamp','deformation','left_fingertip_pad_force','right_fingertip_pad_force','joint_effort','slip_detected','deformation_limit_reached','fingertip_force_limit_reached','gripper_empty','rtstate']
  _slot_types = ['time','float64','float64','float64','float64','bool','bool','bool','bool','pr2_gripper_sensor_msgs/PR2GripperSensorRTState']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,deformation,left_fingertip_pad_force,right_fingertip_pad_force,joint_effort,slip_detected,deformation_limit_reached,fingertip_force_limit_reached,gripper_empty,rtstate

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperSlipServoData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.deformation is None:
        self.deformation = 0.
      if self.left_fingertip_pad_force is None:
        self.left_fingertip_pad_force = 0.
      if self.right_fingertip_pad_force is None:
        self.right_fingertip_pad_force = 0.
      if self.joint_effort is None:
        self.joint_effort = 0.
      if self.slip_detected is None:
        self.slip_detected = False
      if self.deformation_limit_reached is None:
        self.deformation_limit_reached = False
      if self.fingertip_force_limit_reached is None:
        self.fingertip_force_limit_reached = False
      if self.gripper_empty is None:
        self.gripper_empty = False
      if self.rtstate is None:
        self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()
    else:
      self.stamp = genpy.Time()
      self.deformation = 0.
      self.left_fingertip_pad_force = 0.
      self.right_fingertip_pad_force = 0.
      self.joint_effort = 0.
      self.slip_detected = False
      self.deformation_limit_reached = False
      self.fingertip_force_limit_reached = False
      self.gripper_empty = False
      self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I4d4Bb().pack(_x.stamp.secs, _x.stamp.nsecs, _x.deformation, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.slip_detected, _x.deformation_limit_reached, _x.fingertip_force_limit_reached, _x.gripper_empty, _x.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.rtstate is None:
        self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()
      end = 0
      _x = self
      start = end
      end += 45
      (_x.stamp.secs, _x.stamp.nsecs, _x.deformation, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.slip_detected, _x.deformation_limit_reached, _x.fingertip_force_limit_reached, _x.gripper_empty, _x.rtstate.realtime_controller_state,) = _get_struct_2I4d4Bb().unpack(str[start:end])
      self.slip_detected = bool(self.slip_detected)
      self.deformation_limit_reached = bool(self.deformation_limit_reached)
      self.fingertip_force_limit_reached = bool(self.fingertip_force_limit_reached)
      self.gripper_empty = bool(self.gripper_empty)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I4d4Bb().pack(_x.stamp.secs, _x.stamp.nsecs, _x.deformation, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.slip_detected, _x.deformation_limit_reached, _x.fingertip_force_limit_reached, _x.gripper_empty, _x.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.rtstate is None:
        self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()
      end = 0
      _x = self
      start = end
      end += 45
      (_x.stamp.secs, _x.stamp.nsecs, _x.deformation, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.slip_detected, _x.deformation_limit_reached, _x.fingertip_force_limit_reached, _x.gripper_empty, _x.rtstate.realtime_controller_state,) = _get_struct_2I4d4Bb().unpack(str[start:end])
      self.slip_detected = bool(self.slip_detected)
      self.deformation_limit_reached = bool(self.deformation_limit_reached)
      self.fingertip_force_limit_reached = bool(self.fingertip_force_limit_reached)
      self.gripper_empty = bool(self.gripper_empty)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I4d4Bb = None
def _get_struct_2I4d4Bb():
    global _struct_2I4d4Bb
    if _struct_2I4d4Bb is None:
        _struct_2I4d4Bb = struct.Struct("<2I4d4Bb")
    return _struct_2I4d4Bb
